/* This is a file evolved from Folding MicroEmacs 3.10.21a */
/* built by Mike Burrow and Andy Sturgess at Inmos.        */
/* Folding MicroEmacs has ben tested on Sun and PC only.   */
/* Itself based on MicroEmacs 3.10 by Daniel M Kawrence    */
/* and Dave G Conroy.                                      */

/* SccsID[] = "@(#)ebind.h	1.4 95/08/11"; */                            
/*	EBIND:		Initial default key to function bindings for
			MicroEMACS 3.10
*/

/*
 * Command table.
 * This table  is *roughly* in ASCII order, left to right across the
 * characters of the command. This explains the funny location of the
 * control-X commands.
 */

/*	Modifications:
	11-Sep-89	Mike Burrow (INMOS)	Added folding.
*/

NOSHARE KEYTAB	keytab[NBINDS] = {
	{C_TRL|'A',		BINDFNC,	gotobol},
	{C_TRL|'B',		BINDFNC,	backchar},
	{C_TRL|'C',		BINDFNC,	insspace},
	{C_TRL|'D',		BINDFNC,	forwdel},
	{C_TRL|'E',		BINDFNC,	gotoeol},
	{C_TRL|'F',		BINDFNC,	forwchar},
	{C_TRL|'G',		BINDFNC,	ctrlg},
	{C_TRL|'H',		BINDFNC,	backdel},
	{C_TRL|'I',		BINDFNC,	tab},
	{C_TRL|'J',		BINDFNC,	indent},
	{C_TRL|'K',		BINDFNC,	killtext},
	{C_TRL|'L',		BINDFNC,	refresh},
	{C_TRL|'M',		BINDFNC,	newline},
	{C_TRL|'N',		BINDFNC,	bforwline},
	{C_TRL|'O',		BINDFNC,	openline},
	{C_TRL|'P',		BINDFNC,	bbackline},
	{C_TRL|'Q',		BINDFNC,	quote},
	{C_TRL|'R',		BINDFNC,	backsearch},
	{C_TRL|'S',		BINDFNC,	forwsearch}, 
	{C_TRL|'T',		BINDFNC,	twiddle},
	{C_TRL|'U',		BINDFNC,	unarg},
	{C_TRL|'V',		BINDFNC,	forwpage},
	{C_TRL|'W',		BINDFNC,	killregion},
	{C_TRL|'X',		BINDFNC,	cex},
	{C_TRL|'Y',		BINDFNC,	yank},
	{C_TRL|'Z',		BINDFNC,	backpage},
	{C_TRL|'[',		BINDFNC,	meta},
	{CTLX|C_TRL|'B', 	BINDFNC,	listbuffers},
	{CTLX|C_TRL|'C', 	BINDFNC,	quit},
#if	AEDIT
	{CTLX|C_TRL|'D', 	BINDFNC,	detab},
	{CTLX|C_TRL|'E', 	BINDFNC,	entab},
#endif
	{CTLX|C_TRL|'F', 	BINDFNC,	filefind},
	{CTLX|C_TRL|'I', 	BINDFNC,	insfile},
	{CTLX|C_TRL|'K',		BINDFNC,	macrotokey},
	{CTLX|C_TRL|'L', 	BINDFNC,	lowerregion},
	{CTLX|C_TRL|'M', 	BINDFNC,	delmode},
	{CTLX|C_TRL|'N', 	BINDFNC,	mvdnwind},
	{CTLX|C_TRL|'O', 	BINDFNC,	deblank},
	{CTLX|C_TRL|'P', 	BINDFNC,	mvupwind},
	{CTLX|C_TRL|'R', 	BINDFNC,	fileread},
	{CTLX|C_TRL|'S', 	BINDFNC,	filesave}, 
#if	AEDIT
	{CTLX|C_TRL|'T', 	BINDFNC,	trim},
#endif
	{CTLX|C_TRL|'U', 	BINDFNC,	upperregion},
	{CTLX|C_TRL|'V', 	BINDFNC,	viewfile},
	{CTLX|C_TRL|'W', 	BINDFNC,	filewrite},
	{CTLX|C_TRL|'X', 	BINDFNC,	swapmark},
	{CTLX|C_TRL|'Z', 	BINDFNC,	shrinkwind},
	{CTLX|'?',		BINDFNC,	deskey},
	{CTLX|'!',		BINDFNC,	spawn},
	{CTLX|'@',		BINDFNC,	pipecmd},
	{CTLX|'#',		BINDFNC,	filter},
	{CTLX|'$',		BINDFNC,	execprg},
	{CTLX|'=',		BINDFNC,	showcpos},
	{CTLX|'(',		BINDFNC,	ctlxlp},
	{CTLX|')',		BINDFNC,	ctlxrp},
	{CTLX|'<',		BINDFNC,	narrow},
	{CTLX|'>',		BINDFNC,	widen},
	{CTLX|'^',		BINDFNC,	enlargewind},
	{CTLX|' ',		BINDFNC,	remmark},
	{CTLX|'0',		BINDFNC,	delwind},
	{CTLX|'1',		BINDFNC,	onlywind},
	{CTLX|'2',		BINDFNC,	splitwind},
	{CTLX|'A',		BINDFNC,	setvar},
	{CTLX|'B',		BINDFNC,	usebuffer},
	{CTLX|'C',		BINDFNC,	spawncli},
#if	BSD
	{CTLX|'D',		BINDFNC,	bktoshell},
#endif
	{CTLX|'E',		BINDFNC,	ctlxe},
	{CTLX|'F',		BINDFNC,	setfillcol},
#if	DEBUGM
	{CTLX|'G',		BINDFNC,	dispvar},
#endif
	{CTLX|'K',		BINDFNC,	killbuffer},
	{CTLX|'M',		BINDFNC,	setmod},
	{CTLX|'N',		BINDFNC,	filename},
	{CTLX|'O',		BINDFNC,	nextwind},
	{CTLX|'P',		BINDFNC,	prevwind},
#if	ISRCH
	{CTLX|'R',		BINDFNC,	risearch},
	{CTLX|'S',		BINDFNC,	fisearch},
#endif
	{CTLX|'W',		BINDFNC,	resize},
	{CTLX|'X',		BINDFNC,	nextbuffer},
	{CTLX|'Z',		BINDFNC,	enlargewind},
	{META|C_TRL|'A',		BINDFNC,	searchffold}, /* MJB: 21-Sep-89 */
	{META|C_TRL|'B',		BINDFNC,	searchbfold}, /* MJB: 21-Sep-89 */
#if	WORDPRO
	{META|C_TRL|'C', 	BINDFNC,	wordcount},
#endif
	{META|C_TRL|'D',		BINDFNC,	delfold},     /* MJB: 21-Sep-89 */
#if	PROC
	{META|C_TRL|'E', 	BINDFNC,	execproc},
#endif
#if	CFENCE
	{META|C_TRL|'F', 	BINDFNC,	getfence},
#endif
	{META|C_TRL|'G', 	BINDFNC,	gotomark},
	{META|C_TRL|'H', 	BINDFNC,	delbword},
	{META|C_TRL|'I',		BINDFNC,	exitfold},   /* MJB: 11-Sep-89 */
	{META|C_TRL|'J',		BINDFNC,	removefold}, /* MJB: 11-Sep-89 */
	{META|C_TRL|'K', 	BINDFNC,	unbindkey},
	{META|C_TRL|'L', 	BINDFNC,	reposition},
	{META|C_TRL|'M', 	BINDFNC,	delgmode},
	{META|C_TRL|'N', 	BINDFNC,	namebuffer},
	{META|C_TRL|'O',		BINDFNC,	closefold},  /* MJB: 11-Sep-89 */
	{META|C_TRL|'R', 	BINDFNC,	qreplace},
	{META|C_TRL|'S', 	BINDFNC,	execfile}, 
	{META|C_TRL|'V', 	BINDFNC,	nextdown},
#if	WORDPRO
	{META|C_TRL|'W', 	BINDFNC,	killpara},
#endif
	{META|C_TRL|'X', 	BINDFNC,	execcmd},
	{META|C_TRL|'Z', 	BINDFNC,	nextup},
	{META|' ',		BINDFNC,	setmark},
	{META|'?',		BINDFNC,	help},
	{META|'!',		BINDFNC,	reposition},
	{META|'.',		BINDFNC,	setmark},
	{META|'>',		BINDFNC,	gotoeob},
	{META|'<',		BINDFNC,	gotobob},
	{META|'~',		BINDFNC,	unmark},
#if	APROP
	{META|'A',		BINDFNC,	apro},
#endif
	{META|'B',		BINDFNC,	backword},
	{META|'C',		BINDFNC,	capword},
	{META|'D',		BINDFNC,	delfword},
#if	CRYPT
	{META|'E',		BINDFNC,	setekey},
#endif
	{META|'F',		BINDFNC,	forwword},
	{META|'G',		BINDFNC,	gotoline},
	{META|'I',		BINDFNC,	enterfold},  /* MJB: 11-Sep-89 */
	{META|'J',		BINDFNC,	makefold},   /* MJB: 11-Sep-89 */
	{META|'K',		BINDFNC,	bindtokey},
	{META|'L',		BINDFNC,	lowerword},
	{META|'M',		BINDFNC,	setgmode},
#if	WORDPRO
	{META|'N',		BINDFNC,	gotoeop},
#endif
	{META|'O',		BINDFNC,	openfold},   /* MJB: 11-Sep-89 */
#if	WORDPRO
	{META|'P',		BINDFNC,	gotobop},
	{META|'Q',		BINDFNC,	fillpara},
#endif
	{META|'R',		BINDFNC,	sreplace},
#if	BSD
	{META|'S',		BINDFNC,	bktoshell},
#endif
	{META|'T',		BINDFNC,	exitallfolds}, /* MJB: 21-Sep-89 */
	{META|'U',		BINDFNC,	upperword},
	{META|'V',		BINDFNC,	backpage},
	{META|'W',		BINDFNC,	copyregion},
	{META|'X',		BINDFNC,	namedcmd},
	{META|'Z',		BINDFNC,	quickexit},
	{META|0x7F,		BINDFNC,	delbword},

#if	MOUSE
	{MOUS|'a',		BINDFNC,	movemd},
	{MOUS|'b',		BINDFNC,	movemu},
	{MOUS|'e',		BINDFNC,	mregdown},
	{MOUS|'f',		BINDFNC,	mregup},
	{MOUS|'1',		BINDFNC,	resizm},
#endif 

	{ALTD|'S',		BINDFNC,	forwhunt},
	{ALTD|'R',		BINDFNC,	backhunt},
	{SPEC|'<',		BINDFNC,	gotobob},
	{SPEC|'P',		BINDFNC,	bbackline},
	{SPEC|'Z',		BINDFNC,	backpage},
	{SPEC|'B',		BINDFNC,	backchar},
	{SPEC|'F',		BINDFNC,	forwchar},
	{SPEC|'>',		BINDFNC,	gotoeob},
	{SPEC|'N',		BINDFNC,	bforwline},
	{SPEC|'V',		BINDFNC,	forwpage},
	{SPEC|'C',		BINDFNC,	insspace},
	{SPEC|'D',		BINDFNC,	forwdel},
	{SPEC|C_TRL|'B', 	BINDFNC,	backword},
	{SPEC|C_TRL|'F', 	BINDFNC,	forwword},
#if	WORDPRO
	{SPEC|C_TRL|'Z', 	BINDFNC,	gotobop},
	{SPEC|C_TRL|'V', 	BINDFNC,	gotoeop},
#endif
	{SPEC|SHFT|'1', 	BINDFNC,	cbuf1},
	{SPEC|SHFT|'2', 	BINDFNC,	cbuf2},
	{SPEC|SHFT|'3', 	BINDFNC,	cbuf3},
	{SPEC|SHFT|'4', 	BINDFNC,	cbuf4},
	{SPEC|SHFT|'5', 	BINDFNC,	cbuf5},
	{SPEC|SHFT|'6', 	BINDFNC,	cbuf6},
	{SPEC|SHFT|'7', 	BINDFNC,	cbuf7},
	{SPEC|SHFT|'8', 	BINDFNC,	cbuf8},
	{SPEC|SHFT|'9', 	BINDFNC,	cbuf9},
	{SPEC|SHFT|'0', 	BINDFNC,	cbuf10},

#if	HP150
	{SPEC|32,		BINDFNC,	bbackline},
	{SPEC|33,		BINDFNC,	bforwline},
	{SPEC|35,		BINDFNC,	backchar},
	{SPEC|34,		BINDFNC,	forwchar},
	{SPEC|44,		BINDFNC,	gotobob},
	{SPEC|46,		BINDFNC,	forwpage},
	{SPEC|47,		BINDFNC,	backpage},
	{SPEC|82,		BINDFNC,	nextwind},
	{SPEC|68,		BINDFNC,	openline},
	{SPEC|69,		BINDFNC,	killtext},
	{SPEC|65,		BINDFNC,	forwdel},
	{SPEC|64,		BINDFNC,	ctlxe},
	{SPEC|67,		BINDFNC,	refresh},
	{SPEC|66,		BINDFNC,	reposition},
	{SPEC|83,		BINDFNC,	help},
	{SPEC|81,		BINDFNC,	deskey},
#endif

#if	HP110
	{SPEC|0x4b,		BINDFNC,	backchar},
	{SPEC|0x4d,		BINDFNC,	forwchar},
	{SPEC|0x48,		BINDFNC,	bbackline},
	{SPEC|0x50,		BINDFNC,	bforwline},
	{SPEC|0x43,		BINDFNC,	help},
	{SPEC|0x73,		BINDFNC,	backword},
	{SPEC|0x74,		BINDFNC,	forwword},
	{SPEC|0x49,		BINDFNC,	backpage},
	{SPEC|0x51,		BINDFNC,	forwpage},
	{SPEC|84,		BINDFNC,	cbuf1},
	{SPEC|85,		BINDFNC,	cbuf2},
	{SPEC|86,		BINDFNC,	cbuf3},
	{SPEC|87,		BINDFNC,	cbuf4},
	{SPEC|88,		BINDFNC,	cbuf5},
	{SPEC|89,		BINDFNC,	cbuf6},
	{SPEC|90,		BINDFNC,	cbuf7},
	{SPEC|91,		BINDFNC,	cbuf8},
#endif

#if	AMIGA
	{SPEC|'?',		BINDFNC,	help},
	{SPEC|'A',		BINDFNC,	bbackline},
	{SPEC|'B',		BINDFNC,	bforwline},
	{SPEC|'C',		BINDFNC,	forwchar},
	{SPEC|'D',		BINDFNC,	backchar},
	{SPEC|'T',		BINDFNC,	backpage},
	{SPEC|'S',		BINDFNC,	forwpage},
	{SPEC|'a',		BINDFNC,	backword},
	{SPEC|'`',		BINDFNC,	forwword},
	{SPEC|'P',		BINDFNC,	cbuf1},
	{SPEC|'Q',		BINDFNC,	cbuf2},
	{SPEC|'R',		BINDFNC,	cbuf3},
	{SPEC|'S',		BINDFNC,	cbuf4},
	{SPEC|'T',		BINDFNC,	cbuf5},
	{SPEC|'U',		BINDFNC,	cbuf6},
	{SPEC|'V',		BINDFNC,	cbuf7},
	{SPEC|'W',		BINDFNC,	cbuf8},
	{SPEC|'X',		BINDFNC,	cbuf9},
	{SPEC|'Y',		BINDFNC,	cbuf10},
	{127,			BINDFNC,	forwdel},
#endif

#if	ST520
	{SPEC|C_TRL|'5',		BINDFNC,	help},
#endif

#if  WANGPC
	SPEC|0xE0,		BINDFNC,	quit,		/* Cancel */
	SPEC|0xE1,		BINDFNC,	help,		/* Help */
	SPEC|0xF1,		BINDFNC,	help,		/* ^Help */
	SPEC|0xE3,		BINDFNC,	ctrlg,		/* Print */
	SPEC|0xF3,		BINDFNC,	ctrlg,		/* ^Print */
	SPEC|0xC0,		BINDFNC,	bbackline,	/* North */
	SPEC|0xD0,		BINDFNC,	gotobob,	/* ^North */
	SPEC|0xC1,		BINDFNC,	forwchar,	/* East */
	SPEC|0xD1,		BINDFNC,	gotoeol,	/* ^East */
	SPEC|0xC2,		BINDFNC,	bforwline,	/* South */
	SPEC|0xD2,		BINDFNC,	gotobop,	/* ^South */
	SPEC|0xC3,		BINDFNC,	backchar,	/* West */
	SPEC|0xD3,		BINDFNC,	gotobol,	/* ^West */
	SPEC|0xC4,		BINDFNC,	ctrlg,		/* Home */
	SPEC|0xD4,		BINDFNC,	gotobob,	/* ^Home */
	SPEC|0xC5,		BINDFNC,	filesave,	/* Execute */
	SPEC|0xD5,		BINDFNC,	ctrlg,		/* ^Execute */
	SPEC|0xC6,		BINDFNC,	insfile,	/* Insert */
	SPEC|0xD6,		BINDFNC,	ctrlg,		/* ^Insert */
	SPEC|0xC7,		BINDFNC,	forwdel,	/* Delete */
	SPEC|0xD7,		BINDFNC,	killregion,	/* ^Delete */
	SPEC|0xC8,		BINDFNC,	backpage,	/* Previous */
	SPEC|0xD8,		BINDFNC,	prevwind,	/* ^Previous */
	SPEC|0xC9,		BINDFNC,	forwpage,	/* Next */
	SPEC|0xD9,		BINDFNC,	nextwind,	/* ^Next */
	SPEC|0xCB,		BINDFNC,	ctrlg,		/* Erase */
	SPEC|0xDB,		BINDFNC,	ctrlg,		/* ^Erase */
	SPEC|0xDC,		BINDFNC,	ctrlg,		/* ^Tab */
	SPEC|0xCD,		BINDFNC,	ctrlg,		/* BackTab */
	SPEC|0xDD,		BINDFNC,	ctrlg,		/* ^BackTab */
	SPEC|0x80,		BINDFNC,	ctrlg,		/* Indent */
	SPEC|0x90,		BINDFNC,	ctrlg,		/* ^Indent */
	SPEC|0x81,		BINDFNC,	ctrlg,		/* Page */
	SPEC|0x91,		BINDFNC,	ctrlg,		/* ^Page */
	SPEC|0x82,		BINDFNC,	ctrlg,		/* Center */
	SPEC|0x92,		BINDFNC,	ctrlg,		/* ^Center */
	SPEC|0x83,		BINDFNC,	ctrlg,		/* DecTab */
	SPEC|0x93,		BINDFNC,	ctrlg,		/* ^DecTab */
	SPEC|0x84,		BINDFNC,	ctrlg,		/* Format */
	SPEC|0x94,		BINDFNC,	ctrlg,		/* ^Format */
	SPEC|0x85,		BINDFNC,	ctrlg,		/* Merge */
	SPEC|0x95,		BINDFNC,	ctrlg,		/* ^Merge */
	SPEC|0x86,		BINDFNC,	setmark,	/* Note */
	SPEC|0x96,		BINDFNC,	ctrlg,		/* ^Note */
	SPEC|0x87,		BINDFNC,	ctrlg,		/* Stop */
	SPEC|0x97,		BINDFNC,	ctrlg,		/* ^Stop */
	SPEC|0x88,		BINDFNC,	forwsearch,	/* Srch */
	SPEC|0x98,		BINDFNC,	backsearch,	/* ^Srch */
	SPEC|0x89,		BINDFNC,	sreplace,	/* Replac */
	SPEC|0x99,		BINDFNC,	qreplace,	/* ^Replac */
	SPEC|0x8A,		BINDFNC,	ctrlg,		/* Copy */
	SPEC|0x9A,		BINDFNC,	ctrlg,		/* ^Copy */
	SPEC|0x8B,		BINDFNC,	ctrlg,		/* Move */
	SPEC|0x9B,		BINDFNC,	ctrlg,		/* ^Move */
	SPEC|0x8C,		BINDFNC,	namedcmd,	/* Command */
	SPEC|0x9C,		BINDFNC,	spawn,		/* ^Command */
	SPEC|0x8D,		BINDFNC,	ctrlg,		/* ^ */
	SPEC|0x9D,		BINDFNC,	ctrlg,		/* ^^ */
	SPEC|0x8E,		BINDFNC,	ctrlg,		/* Blank */
	SPEC|0x9E,		BINDFNC,	ctrlg,		/* ^Blank */
	SPEC|0x8F,		BINDFNC,	gotoline,	/* GoTo */
	SPEC|0x9F,		BINDFNC,	usebuffer,	/* ^GoTo */
#endif
 
	{0x7F,			BINDFNC,	backdel},

	{0,			BINDNUL,	NULL}
};

