;       WPAGE.CMD:	Wordprocessing Macro Page
;			for folding MicroEMACS 3.10.21e and above
;			(C)opyright 1987 by Daniel M Lawrence
;			last modified 8/Apr/94 by Denis A Nicole
;{{{  store-procedure clean
store-procedure clean
	delete-buffer "[Macro 10]"
       	bind-to-key execute-macro-11 ^XFN2
	bind-to-key execute-macro-12 ^XFN3
	delete-buffer "[Macro 13]"
	delete-buffer "[Macro 14]"
	bind-to-key execute-macro-15 ^XFN6
	delete-buffer "[Macro 16]"
	bind-to-key execute-macro-17 ^XFN8
	bind-to-key execute-macro-18 ^XFN9
	bind-to-key execute-macro-19 ^XFN0
	set $cmode %oldmode
	set $gmode %oldgmode
	write-message " "
!endm
;}}}
; make sure the function key window is up
	set %rcfkeys FALSE
	execute-macro-1
	write-message "Loading..."
;{{{  Write out the page instructions
	save-window
	1 next-window
	beginning-of-file
	set $curcol 25
	overwrite-string " F1 center line                                     "
	next-line
	set $curcol 25
	overwrite-string " F3 reformat paragraph     F4 spell check file      "
	next-line
	set $curcol 25
	overwrite-string " F5 ref indented paragraph                          "
	next-line
	set $curcol 18
	overwrite-string "WORD"
	set $curcol 25
	overwrite-string " F7 toggle words                                    "
	next-line
	set $curcol 25
	overwrite-string " F9 count words                                     "
	unmark-buffer
	beginning-of-file
	!force restore-window
	update-screen
;}}}
;{{{  10      store-macro --- Center the current line
10	store-macro
	end-of-line
	set %rctmp $curcol
	beginning-of-line
	&div &sub $fillcol %rctmp 2 insert-space
	beginning-of-line
!endm
;}}}
bind-to-key nop ^XFN2
bind-to-key fill-paragraph ^XFN3
;{{{  13      store-macro --- Spell check the current buffer
13	store-macro
;	set %rctmp @"User dictionary(<ret> if none): "
	set %rctmp ""
	!if &seq %rctmp "ERROR"
		!return
	!endif
	!if &not &seq %rctmp ""
		set %rctmp &cat " -u" %rctmp
	!endif
	set %rctmp &cat %rctmp " spell.tmp"
	save-file
	set %rcspell TRUE
	write-message ~n
; These commands have been set up for TeX and LaTeX
	shell-command &cat &cat "ndetex -i " $cfname " > spell.tmp"
	shell-command &cat &cat "spell -n" $cfname  %rctmp
	shell-command "rm spell.tmp"
	execute-file "scan.cmd"
	delete-other-windows
	!if &seq %rcfkeys TRUE
		set %rcfkeys FALSE
		execute-macro-1
	!endif
	update-screen
	write-message "[Spell Check complete]"
!endm
;}}}
;{{{  14      store-macro --- reformat indented paragraph
14	store-macro
	set $discmd "FALSE"

	;snarf the paragraph and put it in its own buffer
	kill-region
	2 split-current-window
	select-buffer "[temp]"
	yank

	;get rid of the blank lines at the end
	end-of-file
	!while &and &seq $line "" &not &equ $curline 1
		delete-previous-character
	!endwhile
	forward-character

	;get rid of the indents
	set %endline $curline
	beginning-of-file
	!while &gre %endline $curline
		!while &or &equ $curchar 32 &equ $curchar 9
			delete-next-character
		!endwhile
		next-line
	!endwhile

	;re-format it
	!if &equal $softtab 0 
		&sub $fillcol $hardtab set-fill-column
		beginning-of-file
		; the fill-paragraph fails as it reaches EOF.
		!force fill-paragraph
		&add $fillcol $hardtab set-fill-column
	!else
		&sub $fillcol $softtab set-fill-column
		beginning-of-file
		; the fill-paragraph fails as it reaches EOF.
		!force fill-paragraph
		&add $fillcol $softtab set-fill-column
	!endif
	;insert new indents
	end-of-file
	set %endline $curline
	beginning-of-file
	!while &less $curline %endline
		beginning-of-line
		handle-tab
		next-line
	!endwhile

	;move it back into the original buffer
	beginning-of-file
	set-mark
	end-of-file
	kill-region
	unmark-buffer
	delete-window
	yank

	;and clean up
	delete-buffer "[temp]"
	set $discmd TRUE
	write-message "                    [Fixed paragraph]"
!endm
;}}}
bind-to-key nop ^XFN6
;{{{  16      store-macro --- swap the word the cursor is on and it's predisesor
16	store-macro
	set %rctmp $search
	forward-character
	previous-word
	0 delete-next-word
	set %second $kill
	insert-string "~~"
	!force previous-word
	!if &seq $status FALSE
		set %first %second
	!else
		0 delete-next-word
		set %first $kill
		insert-string %second
	!endif
	search-forward "~~"
	delete-previous-character
	insert-string %first
	previous-word
	set $search %rctmp
!endm
;}}}
bind-to-key nop ^XFN8
bind-to-key count-words ^XFN9
bind-to-key nop ^XFN0
	set %oldmode $cmode
	set %oldgmode $gmode
	add-mode wrap
	add-global-mode wrap
	write-message "[Wordprocesing mode loaded]"
